## simpleitk 1.0.1

=== CMakeLists.txt ===
cmake_minimum_required ( VERSION 3.0 FATAL_ERROR )

# Explicitly add INCREMENTAL linking option to command lines.
# http://www.cmake.org/pipermail/cmake/2010-February/035174.html
SET(MSVC_INCREMENTAL_DEFAULT ON)

project ( SimpleITK )

cmake_policy( VERSION 3.0 )

foreach(p
    CMP0042 # CMake 3.0
    CMP0063 # CMake 3.3.2
    )
  if(POLICY ${p})
    cmake_policy(SET ${p} NEW)
  endif()
endforeach()

# Include extra CMake files
list(INSERT CMAKE_MODULE_PATH 0 "${CMAKE_CURRENT_SOURCE_DIR}/CMake")

#-----------------------------------------------------------------------------
# Version information
include(Version.cmake)

set(SimpleITK_VERSION "${SimpleITK_VERSION_MAJOR}.${SimpleITK_VERSION_MINOR}")
if(DEFINED SimpleITK_VERSION_PATCH)
  set(SimpleITK_VERSION "${SimpleITK_VERSION}.${SimpleITK_VERSION_PATCH}")
  if(DEFINED SimpleITK_VERSION_TWEAK)
    set(SimpleITK_VERSION "${SimpleITK_VERSION}.${SimpleITK_VERSION_TWEAK}")
  endif()
endif()

if(DEFINED SimpleITK_VERSION_RC)
  set(SimpleITK_VERSION "${SimpleITK_VERSION}${SimpleITK_VERSION_RC}")
endif()
if(DEFINED SimpleITK_VERSION_POST)
  set(SimpleITK_VERSION "${SimpleITK_VERSION}.post${SimpleITK_VERSION_POST}")
elseif(DEFINED SimpleITK_VERSION_DEV)
  set(SimpleITK_VERSION "${SimpleITK_VERSION}.dev${SimpleITK_VERSION_DEV}")
endif()

option( SimpleITK_BUILD_DISTRIBUTE "Remove '-g#####' from version. ( for official distribution only )" OFF )
mark_as_advanced( SimpleITK_BUILD_DISTRIBUTE )
if( NOT SimpleITK_BUILD_DISTRIBUTE )
  set(SimpleITK_VERSION "${SimpleITK_VERSION}-g${SimpleITK_VERSION_HASH}")
endif()

message(STATUS "Building SimpleITK version \"${SimpleITK_VERSION}\"")


#-----------------------------------------------------------
# Check and set required flags for compilation
# This must be done before any other try compiles based tests are
# done.
include(sitkCheckRequiredFlags)
include(sitkCompilerWarningsSettings)

include( sitkSITKLegacyNaming )
include( sitkForbidDownloadsOption )
include( sitkTargetUseITK )

find_package(ITK REQUIRED )
#we require certain packages be turned on in ITK
include(sitkCheckForITKModuleDependencies)

if(ITK_FOUND)

  # NOTE: We are purposely not calling UseITK yet. However, we must make
  # sure the requred compilation and linker flags are set. Since, we
  # are trying to encapsulate ITK, we need to very carefully control
  # in access to the headers and libraries, hence each SimpleITK
  # library will call UseITK.

  # Add compiler flags needed to use ITK.
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${ITK_REQUIRED_C_FLAGS}")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${ITK_REQUIRED_CXX_FLAGS}")
  set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} ${ITK_REQUIRED_LINK_FLAGS}")
  set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} ${ITK_REQUIRED_LINK_FLAGS}")
  set(CMAKE_MODULE_LINKER_FLAGS "${CMAKE_MODULE_LINKER_FLAGS} ${ITK_REQUIRED_LINK_FLAGS}")

  link_directories( "${ITK_LIBRARY_DIRS}")


endif()


list(APPEND SimpleITK_PRIVATE_COMPILE_OPTIONS ${CXX_ADDITIONAL_WARNING_FLAGS})

#----------------------------------------------------------
# Place all options to go into sitkConfigure.h here
option(BUILD_SHARED_LIBS "Build SimpleITK ITK with shared libraries. This does not effect wrapped languages." OFF)
set(SITK_BUILD_SHARED_LIBS ${BUILD_SHARED_LIBS})


option(SimpleITK_EXPLICIT_INSTANTIATION "Enable an ITK static library of explicitly instantiated templates." ON)
sitk_legacy_naming(SimpleITK_EXPLICIT_INSTANTIATION)

if ( MSVC AND SITK_BUILD_SHARED_LIBS )
  set( SITK_SimpleITKExplit_STATIC 1 )
endif()

set( SimpleITK_INT64_PIXELIDS_DEFAULT ON )
if( MSVC )
  # See http://www.cmake.org/cmake/help/v2.8.10/cmake.html#variable:MSVC_VERSION
  # and https://en.wikipedia.org/wiki/Microsoft_Visual_Studio#Version_history
  #   1500 = VS  9.0 (Visual Studio 2008)
  #   1600 = VS 10.0 (Visual Studio 2010)
  #   1700 = VS 11.0 (Visual Studio 2012)
  if(MSVC_VERSION VERSION_LESS 1600)
    # with this option on the linker runs out of memory
    set( SimpleITK_INT64_PIXELIDS_DEFAULT OFF )
  endif()
endif()
option( SimpleITK_INT64_PIXELIDS "Instantiate 64-bit integer pixels, including unsigned, vector and label maps."
  ${SimpleITK_INT64_PIXELIDS_DEFAULT} )
sitk_legacy_naming(SimpleITK_INT64_PIXELIDS)


option( SimpleITK_4D_IMAGES "Add Image and I/O support for four spatial dimensions." OFF )
mark_as_advanced( SimpleITK_4D_IMAGES )
sitk_legacy_naming(SimpleITK_4D_IMAGES)


# Setup build locations.
if(NOT CMAKE_RUNTIME_OUTPUT_DIRECTORY)
  set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/bin)
endif()
if(NOT CMAKE_LIBRARY_OUTPUT_DIRECTORY)
  set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/lib)
endif()
if(NOT CMAKE_ARCHIVE_OUTPUT_DIRECTORY)
  set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/lib)
endif()

set ( SimpleITK_INCLUDE_DIRS
      ${CMAKE_SOURCE_DIR}/Code/Common/include
      ${CMAKE_SOURCE_DIR}/Code/Registration/include
      ${CMAKE_SOURCE_DIR}/Code/BasicFilters/include
      ${CMAKE_SOURCE_DIR}/Code/IO/include
      ${CMAKE_BINARY_DIR}/Code/BasicFilters/include
      ${CMAKE_BINARY_DIR}/Code/Common/include
      )

set ( SimpleITK_LIBRARIES SimpleITKCommon SimpleITKIO SimpleITKRegistration )

if (SimpleITK_EXPLICIT_INSTANTIATION)
  list ( APPEND SimpleITK_INCLUDE_DIRS ${CMAKE_SOURCE_DIR}/Code/Explicit/include )
  # This library is linked privately to SimpleITK libraries and is not
  # part of the public link interface
  #list ( APPEND SimpleITK_LIBRARIES  SimpleITKExplicit )
endif()

set( SimpleITK_LIBRARIES ${SimpleITK_LIBRARIES}  CACHE INTERNAL "" )

# Be sure to clear these each time
set ( GENERATED_TEST_LIST "" CACHE INTERNAL "" )
set ( GENERATED_FILTER_LIST "" CACHE INTERNAL "" )
set ( GENERATED_TEST_SOURCE_LIST "" CACHE INTERNAL "" )

# Create cached list of all template components
file( GLOB template_components
      ${SimpleITK_SOURCE_DIR}/ExpandTemplateGenerator/Components/*.h.in
      ${SimpleITK_SOURCE_DIR}/ExpandTemplateGenerator/Components/*.cxx.in
    )
set ( template_components ${template_components} CACHE INTERNAL "" )


#------------------------------------------------------------------------------
# Variables for use in install rules:

if(NOT SimpleITK_INSTALL_RUNTIME_DIR)
  set(SimpleITK_INSTALL_RUNTIME_DIR "bin")
endif()
if(NOT SimpleITK_INSTALL_LIBRARY_DIR)
  set(SimpleITK_INSTALL_LIBRARY_DIR "lib")
endif()
if(NOT SimpleITK_INSTALL_ARCHIVE_DIR)
  set(SimpleITK_INSTALL_ARCHIVE_DIR "lib")
endif()
if(NOT SimpleITK_INSTALL_INCLUDE_DIR)
  set(SimpleITK_INSTALL_INCLUDE_DIR "include/SimpleITK-${SimpleITK_VERSION_MAJOR}.${SimpleITK_VERSION_MINOR}")
endif()
if(NOT SimpleITK_INSTALL_DOC_DIR)
  set(SimpleITK_INSTALL_DOC_DIR share/doc/SimpleITK-${SimpleITK_VERSION_MAJOR}.${SimpleITK_VERSION_MINOR})
endif()
if(NOT SimpleITK_INSTALL_PACKAGE_DIR)
  set(SimpleITK_INSTALL_PACKAGE_DIR "${SimpleITK_INSTALL_LIBRARY_DIR}/cmake/SimpleITK-${SimpleITK_VERSION_MAJOR}.${SimpleITK_VERSION_MINOR}")
endif()

function(sitk_install_exported_target tgt)
  # Remove the build tree's SimpleITKTargets file if this is the first call:
  get_property(first_time GLOBAL PROPERTY SimpleITK_FIRST_EXPORTED_TARGET)
  if(NOT first_time)
    file(REMOVE ${CMAKE_BINARY_DIR}/SimpleITKTargets.cmake)
    set_property(GLOBAL PROPERTY SimpleITK_FIRST_EXPORTED_TARGET 1)
  endif()

  get_target_property( type ${tgt} TYPE )
  if (type STREQUAL "STATIC_LIBRARY" OR
      type STREQUAL "MODULE_LIBRARY" OR
      type STREQUAL "SHARED_LIBRARY")
    set_property(TARGET ${tgt} PROPERTY VERSION 1)
    set_property(TARGET ${tgt} PROPERTY SOVERSION 1)
    set_property(TARGET ${tgt} PROPERTY
      OUTPUT_NAME ${tgt}-${SimpleITK_VERSION_MAJOR}.${SimpleITK_VERSION_MINOR})
  endif()

  export(TARGETS ${tgt}
    APPEND FILE "${CMAKE_BINARY_DIR}/SimpleITKTargets.cmake"
    )

  install(TARGETS ${tgt}
    EXPORT SimpleITKTargets
    RUNTIME DESTINATION ${SimpleITK_INSTALL_RUNTIME_DIR}
    LIBRARY DESTINATION ${SimpleITK_INSTALL_LIBRARY_DIR}
    ARCHIVE DESTINATION ${SimpleITK_INSTALL_ARCHIVE_DIR}
    )
endfunction()

include(sitkStripOption)

#------------------------------------------------------------------------------
# These are some system specific compiler options needed to build SimpleITK

include(CheckCXXCompilerFlag)

if( NOT DEFINED CMAKE_POSITION_INDEPENDENT_CODE )
  set( CMAKE_POSITION_INDEPENDENT_CODE 1 )
endif()


if( NOT DEFINED CMAKE_C_VISIBILITY_PRESET )
  set(CMAKE_C_VISIBILITY_PRESET hidden)
endif()

if( NOT DEFINED CMAKE_CXX_VISIBILITY_PRESET )
  set(CMAKE_CXX_VISIBILITY_PRESET hidden)
endif()

if( NOT DEFINED CMAKE_VISIBILITY_INLINES_HIDDEN )
  set( CMAKE_VISIBILITY_INLINES_HIDDEN 1 )
endif()


#-----------------------------------------------------------
# Place all checks and try compile variable for sitkConfigure.h here

include(sitkCheckCXX11)


include(CheckIncludeFileCXX)


# check for stdint
# This generates a configuration error if the compiler is not supported
check_include_file_cxx( stdint.h SITK_HAS_STDINT_H )
if(NOT SITK_HAS_STDINT_H)
    if(MSVC)
      add_subdirectory("${SimpleITK_SOURCE_DIR}/Utilities/C99")
    else()
      message(FATAL_ERROR "Unable to find require \"stdint.h\" header file.")
    endif()
endif()

#------------------------------------------------------------------------------
# assemble a list of important documentation from Simple ITK and ITK

set ( SimpleITK_DOC_FILES
  "${CMAKE_CURRENT_SOURCE_DIR}/LICENSE"
  "${CMAKE_CURRENT_SOURCE_DIR}/NOTICE"
  "${CMAKE_CURRENT_SOURCE_DIR}/Readme.md"
  )

# add important files from ITK

# if using from build tree then ITK_USE_FILE will be
# ITK_SOURCE_DIR/CMake/UseITK.cmake. The needed docs should be in the
# root of the source tree
get_filename_component( _itk_root "${ITK_USE_FILE}" PATH )
get_filename_component( _itk_root "${_itk_root}" PATH )
set( _itk_source_path "${_itk_root}" )

get_filename_component( _itk_root "${_itk_root}" PATH )
get_filename_component( _itk_root "${_itk_root}" PATH )
set( _itk_doc_path "${_itk_root}/share/doc/ITK-${ITK_VERSION_MAJOR}.${ITK_VERSION_MINOR}" )

if( EXISTS "${_itk_source_path}/NOTICE" )
  set( ITK_DOC_FILES
    # "${_itk_source_path}/LICENSE" SimpleITK has same license file
    "${_itk_source_path}/NOTICE"
    "${_itk_source_path}/README.txt"
    )
elseif( EXISTS "${_itk_doc_path}/NOTICE" )
  set( ITK_DOC_FILES
    # "${_itk_doc_path}/LICENSE" SimpleITK has same license file
    "${_itk_doc_path}/NOTICE"
    "${_itk_doc_path}/README.txt"
    )
else()
  message( "doc_path: ${_itk_doc_path}" )
  message( WARNING "Unable to file ITK's NOTICE File!\n This file will not be included in SimpleITK packaging!" )
endif()


foreach(_f IN LISTS ITK_DOC_FILES)
  get_filename_component( _name "${_f}" NAME )
  set( _o "${CMAKE_CURRENT_BINARY_DIR}/ITK-${ITK_VERSION_MAJOR}.${ITK_VERSION_MINOR}-${_name}" )
  configure_file( "${_f}"  "${_o}" )
  list( APPEND SimpleITK_DOC_FILES "${_o}" )
endforeach()


#------------------------------------------------------------------------------
# Set up Documentation
include(${SimpleITK_SOURCE_DIR}/Utilities/Doxygen/Doxygen.cmake)

#------------------------------------------------------------------------------
# Set up wrapping.
#
# Use CMake file which present options for wrapped languages, and finds languages as needed
#
include(sitkLanguageOptions)

#------------------------------------------------------------------------------
# Ensure that development strips have been setup
include(sitkCheckSourceTree)

#-----------------------------------------------------------------------------
if(NOT EXISTS "${SimpleITK_SOURCE_DIR}/.ExternalData/README.rst")
  # This file is always present in version-controlled source trees
  # so we must have been extracted from a source tarball with no
  # data objects needed for testing.  Turn off tests by default
  # since enabling them requires network access or manual data
  # store configuration.
  option(BUILD_TESTING "Build the testing tree." OFF)
endif()

=== Code/CMakeLists.txt ===
if (SimpleITK_EXPLICIT_INSTANTIATION)
  add_subdirectory(Explicit)
endif()
add_subdirectory(Common)

add_subdirectory(BasicFilters)
add_subdirectory(IO)
add_subdirectory(Registration)

=== Documentation/CMakeLists.txt ===
add_subdirectory(Tutorials)

=== Examples/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8)
project(SimpleITKExamples)

foreach(p
    CMP0042 # CMake 3.0
    CMP0063 # CMake 3.3.2
    )
  if(POLICY ${p})
    cmake_policy(SET ${p} NEW)
  endif()
endforeach()

if(NOT CMAKE_PROJECT_NAME STREQUAL "SimpleITK")
  find_package(SimpleITK REQUIRED)

endif()

# Add individual cxx executables

add_executable ( SimpleGaussianFunctional SimpleGaussianFunctional.cxx )
target_link_libraries ( SimpleGaussianFunctional ${SimpleITK_LIBRARIES} )

add_executable ( BufferImportExport BufferImportExport.cxx )
target_link_libraries ( BufferImportExport ${SimpleITK_LIBRARIES} )

# Add subdirectories
add_subdirectory(Segmentation)

# Test data directory
set(TEST_HARNESS_TEMP_DIRECTORY ${SimpleITK_BINARY_DIR}/Testing/Temporary)
set(TEST_HARNESS_DATA_DIRECTORY ${SimpleITK_BINARY_DIR}/ExternalData/Testing/Data)
set(ITK_TEST_DRIVER  "$<TARGET_FILE:itkTestDriver>")


# Add example organized sub-directories with multiple languages
add_subdirectory(SimpleGaussian)
add_subdirectory(ImageRegistrationMethod1)
add_subdirectory(ImageRegistrationMethod2)
add_subdirectory(ImageRegistrationMethod3)
add_subdirectory(ImageRegistrationMethod4)
add_subdirectory(ImageRegistrationMethodBSpline1)
add_subdirectory(ImageRegistrationMethodBSpline2)
add_subdirectory(ImageRegistrationMethodDisplacement1)
add_subdirectory(ImageRegistrationMethodExhaustive)
add_subdirectory(N4BiasFieldCorrection)
add_subdirectory(DicomSeriesReader)
add_subdirectory(DicomImagePrintTags)
add_subdirectory(DicomSeriesReadModifyWrite)
add_subdirectory(FilterProgressReporting)
add_subdirectory(DemonsRegistration1)
add_subdirectory(DemonsRegistration2)

macro(add_language_subdirectory lang)
  string(TOUPPER ${lang} LANG)
  if ( WRAP_${LANG} )
    add_subdirectory(${lang})
  endif()
endmacro()

if ( BUILD_TESTING )
  add_subdirectory( test )

  add_language_subdirectory( CSharp )
  add_language_subdirectory( Python )

endif()

=== SuperBuild/CMakeLists.txt ===

#-----------------------------------------------------------------------------
# Override defaults set in initial "project" call, allow user to
# override from command line
#-----------------------------------------------------------------------------


# SimpleITK Addition: install to the common library
# directory, so that all libs/include etc ends up
# in one common tree
if( NOT DEFINED CMAKE_INSTALL_PREFIX )
  set(CMAKE_INSTALL_PREFIX ${CMAKE_CURRENT_BINARY_DIR} CACHE PATH "Where all the prerequisite libraries go")
endif()

cmake_minimum_required ( VERSION 3.0 )
project ( SuperBuildSimpleITK )


#-----------------------------------------------------------------------------
# CMAKE_CXX_COMPILER_ARG1 is a CMake internal variable. It should not be
# used in SimpleITK Superbuild's configuration as it will not get
# correctly propagated to external projects. If it is set, it most
# likely means that SimpleITK is to be built with a launcher such as
# ccache or distcc. This should be done with the CMake variable
# CMAKE_CXX_COMPILER_LAUNCHER_FLAG available in CMake > 3.4.0 .
if(CMAKE_CXX_COMPILER_ARG1)
  message(WARNING "The CMake variable CMAKE_CXX_COMPILER_ARG1 is\
set. The CMake variable CMAKE_CXX_COMPILER_LAUNCHER_FLAG should be used
instead (CMake>=3.4 required).")
endif()

#-----------------------------------------------------------------------------
# Superbuild script
#-----------------------------------------------------------------------------

# Actually run the super build script
set(${CMAKE_PROJECT_NAME}_DEPENDENCIES "") #Dependancies will be determined during superbuild stage.
include("${CMAKE_CURRENT_SOURCE_DIR}/SuperBuild.cmake")

=== Testing/CMakeLists.txt ===
add_subdirectory(Unit)

=== Wrapping/CMakeLists.txt ===

# A general packaging target, not built by default, to build packages for each
# language.  This should depend on all language specific targets.

add_custom_target( dist ${CMAKE_COMMAND} -E echo "Finished generating wrapped packages for distribution..." )

#
# lua SWIG configuration
#
if ( WRAP_LUA )
  add_subdirectory ( Lua )
endif()

#
# python SWIG configuration
#
if ( WRAP_PYTHON )
  add_subdirectory ( Python )
endif()

#
# ruby SWIG configuration
#
if ( WRAP_RUBY )
  add_subdirectory ( Ruby )
endif()

#
# JAVA SWIG configuration
#
if ( WRAP_JAVA )
  add_subdirectory( Java )
endif()

#
# C# SWIG configuration
#
if ( WRAP_CSHARP )
  add_subdirectory ( CSharp )
endif()

#
# TCL SWIG configuration
#
if ( WRAP_TCL )
  add_subdirectory ( Tcl )
endif()

#
# R SWIG configuration
#
if ( WRAP_R )
  add_subdirectory( R )
endif()

=== Code/BasicFilters/CMakeLists.txt ===


# Set up code generation
include(sitkGenerateFilterSource)
generate_filter_source()

add_subdirectory( src )

=== Code/Common/CMakeLists.txt ===

add_subdirectory( src )

# CMake option variable are prefixes with the project name "SimpleITK"
# while C++ preprocess defines only have SITK. These variable need the
# prefix translation.
set( SITK_INT64_PIXELIDS ${SimpleITK_INT64_PIXELIDS} )
set( SITK_4D_IMAGES ${SimpleITK_4D_IMAGES} )
set( SITK_EXPLICIT_INSTANTIATION ${SimpleITK_EXPLICIT_INSTANTIATION} )

include(sitkCheckTemplateDisambiguation)

configure_file( "src/sitkConfigure.h.in" "include/sitkConfigure.h" )
install(FILES "${CMAKE_CURRENT_BINARY_DIR}/include/sitkConfigure.h"
  DESTINATION "${SimpleITK_INSTALL_INCLUDE_DIR}"
  COMPONENT Development)

configure_file("src/sitkVersionConfig.h.in" "include/sitkVersionConfig.h" @ONLY)
install(FILES "${CMAKE_CURRENT_BINARY_DIR}/include/sitkVersionConfig.h"
  DESTINATION "${SimpleITK_INSTALL_INCLUDE_DIR}"
  COMPONENT Development)

=== Code/Explicit/CMakeLists.txt ===

add_subdirectory( src )

=== Documentation/Tutorials/CMakeLists.txt ===
find_package(LATEX)

if(NOT PDFLATEX_COMPILER)
  message(FATAL_ERROR "pdflatex compiler was not found. Please pass to advanced mode and provide its full path")
endif()

add_subdirectory(Short)
add_subdirectory(Medium)

=== Documentation/docs/Makefile ===
# Minimal makefile for Sphinx documentation
#

# You can set these variables from the command line.
SPHINXOPTS    =
SPHINXBUILD   = sphinx-build
SPHINXPROJ    = SimpleITK
SOURCEDIR     = source
BUILDDIR      = build

# Put it first so that "make" without argument is like "make help".
help:
	@$(SPHINXBUILD) -M help "$(SOURCEDIR)" "$(BUILDDIR)" $(SPHINXOPTS) $(O)

.PHONY: help Makefile

# Catch-all target: route all unknown targets to Sphinx using the new
# "make mode" option.  $(O) is meant as a shortcut for $(SPHINXOPTS).
%: Makefile
	@$(SPHINXBUILD) -M $@ "$(SOURCEDIR)" "$(BUILDDIR)" $(SPHINXOPTS) $(O)

=== debian/changelog ===
simpleitk (1.0.1-2) unstable; urgency=medium

  * Cherry-pick upstream fix for FTBFS on i386.
    Thanks to Adrian Bunk for reporting (Closes: #892459)
  * Point the VCS URIs to salsa.debian.org
  * Bump the debhelper version to 11
  * Bump the standards version to 4.1.3
  * Include the NOTICE file in binary packages

 -- Ghislain Antony Vaillant <ghisvail@gmail.com>  Tue, 13 Mar 2018 09:08:40 +0000

simpleitk (1.0.1-1) unstable; urgency=low

  * Initial release. (Closes: #740296)

 -- Ghislain Antony Vaillant <ghisvail@gmail.com>  Thu, 02 Nov 2017 08:49:18 +0000

=== debian/control ===
Source: simpleitk
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Ghislain Antony Vaillant <ghisvail@gmail.com>
Section: libs
Priority: optional
Build-Depends: cmake (>= 3.0),
               debhelper (>= 11),
               dh-python,
               dpkg-dev (>= 1.17.14),
               googletest <!nocheck>,
               libfftw3-dev,
               libinsighttoolkit4-dev (>= 4.11),
               lua5.1,
               python3-dev,
               python3-numpy,
               python3-setuptools,
               swig (>= 3.0.12)
Standards-Version: 4.1.3
Vcs-Browser: https://salsa.debian.org/med-team/simpleitk
Vcs-Git: https://salsa.debian.org/med-team/simpleitk.git
Homepage: http://www.simpleitk.org/

Package: libsimpleitk1.0
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends},
         ${shlibs:Depends}
Description: cross-platform image analysis toolkit
 SimpleITK is an image analysis toolkit with a large number of components
 supporting general filtering operations, image segmentation and registration.
 It is built on top of the Insight Segmentation and Registration Toolkit ITK
 with the intent of providing a simplified interface to ITK. SimpleITK itself is
 written in C++ but is available for a large number of programming languages.
 .
 This package provides the shared libraries.

Package: libsimpleitk1-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: ${misc:Depends},
         ${shlibs:Depends},
         libsimpleitk1.0 (= ${binary:Version})
Description: development files for SimpleITK
 SimpleITK is an image analysis toolkit with a large number of components
 supporting general filtering operations, image segmentation and registration.
 It is built on top of the Insight Segmentation and Registration Toolkit ITK
 with the intent of providing a simplified interface to ITK. SimpleITK itself is
 written in C++ but is available for a large number of programming languages.
 .
 This package provides the development files.

Package: python3-simpleitk
Architecture: any
Section: python
Depends: ${misc:Depends},
         ${python3:Depends},
         ${shlibs:Depends}
Description: Python bindings for SimpleITK
 SimpleITK is an image analysis toolkit with a large number of components
 supporting general filtering operations, image segmentation and registration.
 It is built on top of the Insight Segmentation and Registration Toolkit ITK
 with the intent of providing a simplified interface to ITK. SimpleITK itself is
 written in C++ but is available for a large number of programming languages.
 .
 This package provides the Python bindings.

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

export DEB_BUILD_MAINT_OPTIONS=hardening=+all

BUILDDIR=$(CURDIR)/SimpleITK-build
DESTDIR=$(CURDIR)/debian/tmp

BUILD_OPTIONS=-DBUILD_EXAMPLES:BOOL=OFF \
	-DBUILD_SHARED_LIBS:BOOL=ON \
	-DExternalData_OBJECT_STORES:PATH=$(CURDIR)/data/.ExternalData \
	-DSimpleITK_4D_IMAGES:BOOL=ON \
	-DSimpleITK_BUILD_DISTRIBUTE:BOOL=ON \
	-DSimpleITK_EXPLICIT_INSTANTIATION:BOOL=OFF \
	-DSimpleITK_FORBID_DOWNLOADS:BOOL=ON \
	-DSimpleITK_INSTALL_ARCHIVE_DIR:PATH=lib/$(DEB_HOST_MULTIARCH) \
	-DSimpleITK_INSTALL_LIBRARY_DIR:PATH=lib/$(DEB_HOST_MULTIARCH) \
	-DWRAP_DEFAULT:BOOL=OFF

ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
BUILD_OPTIONS+=-DBUILD_TESTING:BOOL=ON \
	-DGTEST_ROOT:PATH=/usr/src/googletest
else
BUILD_OPTIONS+=-DBUILD_TESTING:BOOL=OFF
endif

PYTHON3:=$(shell py3versions -d)

BUILD_OPTIONS+=-DWRAP_PYTHON:BOOL=ON \
	-DSimpleITK_PYTHON_USE_VIRTUALENV:BOOL=OFF \
	-DSimpleITK_PYTHON_WHEEL:BOOL=OFF \
	-DPYTHON_EXECUTABLE:FILEPATH=/usr/bin/$(PYTHON3)

%:
	dh $@ --with python3 --builddirectory=$(BUILDDIR)

override_dh_auto_configure:
	dh_auto_configure -- $(BUILD_OPTIONS)

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	LD_LIBRARY_PATH=$(BUILDDIR)/lib dh_auto_test
endif

override_dh_auto_install:
	dh_auto_install
	cd $(BUILDDIR)/Wrapping/Python/Packaging \
		&& $(PYTHON3) setup.py install --root $(DESTDIR) --install-layout=deb

override_dh_installdocs:
	dh_installdocs NOTICE

=== debian/watch ===
version=4
opts=uversionmangle=s/(rc|a|b|c)/~$1/
    https://github.com/SimpleITK/SimpleITK/releases \
    .*/SimpleITK@ANY_VERSION@@ARCHIVE_EXT@ debian
opts=component=data,uversionmangle=s/(rc|a|b|c)/~$1/ \
    https://github.com/SimpleITK/SimpleITK/releases \
    .*/SimpleITKData@ANY_VERSION@@ARCHIVE_EXT@ same
